part of aargul_crud;

class AargulCrudOptions {
  final Map<String, AargulCrudField> fields;

  final Stream<AargulCrudDataResponse>? stream;
  final Function(Map<String, dynamic> values)? create;
  final Function(Map<String, dynamic> values)? update;
  final Function(Map<String, dynamic> values)? delete;
  final FutureOr<AargulCrudDataResponse> Function(int startIndex, int count)?
      read;
  final FutureOr<AargulCrudDataResponse> Function(
      double radiusInKm, LatLng center)? geoRead;

  final String Function(Map<String, dynamic> values)? getKey;

  AargulCrudOptions({
    required this.fields,
    this.geoRead,
    this.create,
    this.update,
    this.delete,
    this.read,
    this.stream,
    this.getKey,
  });
}

extension WaitForNextStream<T> on Stream<T> {
  Future<T> get nextEvent async {
  Completer<T> complete = Completer();
  asBroadcastStream().
    listen((event) {
      complete.complete(event);
    });
  return complete.future;
}
}